"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.APIError = void 0;
const http_1 = __importDefault(require("http"));
class APIError extends Error {
    constructor(status, message, options) {
        if (!message) {
            message = http_1.default.STATUS_CODES[status] || 'Unknown';
        }
        super(message);
        Object.defineProperty(this, 'name', { enumerable: false, value: this.constructor.name });
        Object.defineProperty(this, 'status', { enumerable: false, value: status });
        Object.defineProperty(this, 'code', { enumerable: false, value: options === null || options === void 0 ? void 0 : options.code });
        Object.defineProperty(this, 'details', { enumerable: false, value: options === null || options === void 0 ? void 0 : options.details });
    }
}
exports.APIError = APIError;
exports.default = APIError;
//# sourceMappingURL=apiError.js.map